local State = FlexBar2.OO.Mixin
{
	"State_Update",
	"State_Usable",
	"State_Item",
}

function State:Activate()
	self.State = {};
	self:RegisterEvent("FB2_UPDATE", "State_Update");
	self:RegisterEvent("UNIT_MANA", "State_Usable");
	self:RegisterEvent("UNIT_RAGE", "State_Usable");
	self:RegisterEvent("UNIT_ENERGY", "State_Usable");
	self:RegisterEvent("BAG_UPDATE", "State_Item");
end

function State:State_Usable()
	if(type(self.Settings) == "table" and type(self.Settings.Attributes) == "table" and self.Settings.Attributes.type == "action") then
		if(IsUsableAction(self.Settings.Attributes.action) == 1) then
			self.State.Usable = true;
		else
			self.State.Usable = false;
		end
	else
		self.State.Usable = true;
	end
end

function State:State_Update()
	if(type(self.Settings) == "table" and type(self.Settings.Attributes) == "table" and self.Settings.Attributes.type == "action") then
		if(ActionHasRange(self.Settings.Attributes.action)) then
			if(not UnitExists("target") or IsActionInRange(self.Settings.Attributes.action) ~= 0) then
				self.State.Range = true;
			else
				self.State.Range = false;
			end
		end
		if(FlexBar2.db.profile.Ticker == "global") then
			local start, duration, enable = GetActionCooldown(self.Settings.Attributes.action);
			if (duration <= 1.5) then
				self.State.Cooldown = true;
			else
				self.State.Cooldown = false;
			end
		else
			self.State.Cooldown = true;
		end
	else
		self.State.Range = true;
		self.State.Cooldown = true;
	end
	for _, State in pairs(self.State) do
		if(State == false) then
			self.Frame.Icon:SetVertexColor(0.5,0.5,0.5);
			return;
		end
	end
	self.Frame.Icon:SetVertexColor(1,1,1);
end

function State:State_Item()
	if(type(self.Settings) == "table" and type(self.Settings.Attributes) == "table" and self.Settings.Attributes.type == "action"
	and IsConsumableAction(self.Settings.Attributes.action) and GetActionCount(self.Settings.Attributes.action) == 0) then
		self.State.Item = false;
	else
		self.State.Item = true;
	end
end

FlexBar2:RegisterHandler(State);
