local Tooltips = FlexBar2.OO.Mixin 
{
	"GetAction",
	"ShowTooltip",
	"HideTooltip",
	"UpdateTooltip",
	"ClearActionCache",
};


function Tooltips:Activate()
	self:RegisterScript("OnEnter","ShowTooltip")
	self:RegisterScript("OnLeave","HideTooltip")
	self:RegisterEvent("FB2_UPDATE","UpdateTooltip")
	self:RegisterScript("OnAttributeChanged","ClearActionCache")
end

function Tooltips:GetAction()
	if not self.cached_getaction then
		self.cached_getaction = SecureButton_GetModifiedAttribute(self.Frame, "action", SecureStateChild_GetEffectiveButton(self.Frame)) or 1
	end
	return self.cached_getaction
end

function Tooltips:ShowTooltip()
	local Frame = self.Frame
	if ( GetCVar("UberTooltips") == "1" ) then
		GameTooltip_SetDefaultAnchor(GameTooltip, Frame)
	else
		GameTooltip:SetOwner(Frame, "ANCHOR_RIGHT")
	end
	
	if ( GameTooltip:SetAction(self:GetAction()) ) then
		self.updateTooltip = true
	else
		self.updateTooltip = nil
	end
end

function Tooltips:HideTooltip()
	self.updateTooltip = nil
	GameTooltip:Hide()
end

function Tooltips:UpdateTooltip()
	if not self.updateTooltip then return end

	if ( GameTooltip:IsOwned(self.Frame) ) then
		self:ShowTooltip()
	else
		self.updateTooltip = nil
	end
end

function Tooltips:ClearActionCache()
	self.cached_getaction = nil
end

FlexBar2:RegisterHandler(Tooltips);

